/* ---------------------------------------------------------------------------


  This file is part of the ``be'' package of NuSMV version 2. 
  Copyright (C) 2000-2001 by FBK-irst and University of Trento. 

  NuSMV version 2 is free software; you can redistribute it and/or 
  modify it under the terms of the GNU Lesser General Public 
  License as published by the Free Software Foundation; either 
  version 2 of the License, or (at your option) any later version.

  NuSMV version 2 is distributed in the hope that it will be useful, 
  but WITHOUT ANY WARRANTY; without even the implied warranty of 
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public 
  License along with this library; if not, write to the Free Software 
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA.

  For more information on NuSMV see <http://nusmv.fbk.eu>
  or email to <nusmv-users@fbk.eu>.
  Please report bugs to <nusmv-users@fbk.eu>.

  To contact the NuSMV development board, email to <nusmv@fbk.eu>. 

-----------------------------------------------------------------------------*/

/*!
  \author Roberto Cavada
  \brief Contains initialization and deinitialization code for this
  module

  Contains code to be called when entering and exiting the module

*/


#include "nusmv/core/be/be.h"
#include "nusmv/core/be/beInt.h"
#include "nusmv/core/rbc/rbc.h"

/*---------------------------------------------------------------------------*/
/* Variable definitions                                                      */
/*---------------------------------------------------------------------------*/

void Be_Init()
{
  Rbc_pkg_init();
}

void Be_Quit()
{
  Rbc_pkg_quit();
}
